#include<stdio.h>
#include<stdlib.h>
#include<sys/types.h>
#include<sys/stat.h>
#include<unistd.h>
#include<fcntl.h>
/*#include<epplet.h>*/
#include"E-Battery.h"

/* ѿ */
color_t	g_barcolor_high = {64, 64, 255};
color_t	g_barcolor_low = {255, 255, 0};
color_t	g_barcolor_critical = {255, 0, 0};
color_t	g_barcolor_charging = {64, 255, 64};

/* ؿץȥ */
static	int	my_init(int argc, char* argv[], apm_t* apm);
static	void	terminate();
static	void	handle_close(void* data);
static	void	handle_timer(void* data);
static	void	handle_expose(void* d, Window win, int x, int y, int w, int h);
static	int	read_proc(apm_t* apm, char buff[], size_t buffsize);
static	int	decode_proc(apm_t* apm, char buff[]);
static	int	render_stat(apm_t* apm);
static	int	render_label(apm_t* apm);
static	int	render_bar_frame(apm_t* apm);
static	int	render_bar_normal(apm_t* apm, color_t* color);
static	int	render_bar_nobattery(apm_t* apm);
static	int	render_bar_unknown(apm_t* apm);
static	void	print_err(char* file, long line, int is_syserr, int level);
#define	PRINT_ERR(s, l)	{print_err(__FILE__, __LINE__, s, l);}

int main(int argc, char* argv[]){
	apm_t	apm;
	Epplet_gadget	btn_close;

	/* λؿϿ */
	atexit(terminate);
	
	/* Ƽ */
	if(my_init(argc, argv, &apm) != 0){
		PRINT_ERR(0, ERR_ERROR);
		exit(1);
	}
	Epplet_Init(
		EPPLET_NAME,
		EPPLET_VERSION,
		EPPLET_DESCRIPTION,
		EPPLET_WIDTH,
		EPPLET_HEIGHT,
		argc, argv,
		0
	);
	apm.epplet_window = Epplet_get_main_window();

	/* åȺ */
	btn_close = Epplet_create_std_button("CLOSE", 2, 2, handle_close, NULL);
	apm.lbl = Epplet_create_label(LBL_LEFT, LBL_TOP, "2", LBL_SIZE);
	
	/* åɽ */
	Epplet_gadget_show(btn_close);
	Epplet_gadget_show(apm.lbl);

	Epplet_register_expose_handler(handle_expose, &apm);
	Epplet_timer(handle_timer, &apm, 0.0, "TIMER");

	/* ɥɽ */
	Epplet_show();

	/* 롼 */
	Epplet_Loop();

	return 0;
}

int my_init(int argc, char* argv[], apm_t* apm){
	/* apmե򳫤 */
	apm->proc_fd = open(APM_PROC, O_RDONLY, S_IRUSR);
	if(apm->proc_fd == -1){
		PRINT_ERR(1, ERR_ERROR);
		return -1;
	}

	/* С迧 */
	apm->barcolor_high = g_barcolor_high;
	apm->barcolor_low = g_barcolor_low;
	apm->barcolor_critical = g_barcolor_critical;
	apm->barcolor_charging = g_barcolor_charging;

	return 0;
}

void terminate(){
}

void handle_close(void* data){
	Epplet_unremember();
	Esync();
	exit(0);
}

void handle_timer(void* data){
	apm_t*	apm = (apm_t*)data;
	char	buff[BUFF_SIZE];
	
    if(read_proc(apm, buff, sizeof(buff))){
		PRINT_ERR(0, ERR_ERROR);
        handle_close(NULL);
    }
    if(decode_proc(apm, buff)){
		PRINT_ERR(0, ERR_ERROR);
        handle_close(NULL);
    }
    if(render_stat(apm)){
		PRINT_ERR(0, ERR_ERROR);
        handle_close(NULL);
    }

	Epplet_timer(handle_timer, data, INTERVAL, "TIMER");
}

void handle_expose(void* d, Window win, int x, int y, int w, int h){
	handle_timer(d);
}

int read_proc(apm_t* apm, char buff[], size_t buff_size){
    ssize_t len;

    if(lseek(apm->proc_fd, 0, SEEK_SET) != 0){
		PRINT_ERR(1, ERR_ERROR);
        return -1;
    }

    if((len = read(apm->proc_fd, buff, buff_size)) == -1){
		PRINT_ERR(1, ERR_ERROR);
        return -1;
    }
    buff[len] = '\0';

    return 0;
}

int decode_proc(apm_t* apm, char buff[]){
    int n;

    n = sscanf(
        buff, PROC_FORMAT,
        &apm->driver_version, &apm->bios_version, &apm->flags,
        &apm->line_status, &apm->battery_status, &apm->battery_flag,
        &apm->remain_percent, &apm->remain_time, apm->unit
    );

    return 0;
}

int render_stat(apm_t* apm){
	int	call_result;

    /* ٥ѹ */
	call_result = render_label(apm);
	if(call_result != 0){
		PRINT_ERR(0, ERR_ERROR);
		return call_result;
	}
	
	/* СγȤ */
	call_result = render_bar_frame(apm);
	if(call_result != 0){
		PRINT_ERR(0, ERR_ERROR);
		return call_result;
	}

	/* СȤɽ */
	if(apm->battery_flag == BATTERY_FLAG_UNKNOWN){
		call_result = render_bar_unknown(apm);
	}else if((apm->battery_flag & BATTERY_FLAG_NOBATTERY) != 0){
		call_result = render_bar_nobattery(apm);
	}else if((apm->battery_flag & BATTERY_FLAG_CHARGING) != 0){
		call_result = render_bar_normal(apm, &apm->barcolor_charging);
	}else if((apm->battery_flag & BATTERY_FLAG_HIGH) != 0){
		call_result = render_bar_normal(apm, &apm->barcolor_high);
	}else if((apm->battery_flag & BATTERY_FLAG_LOW) != 0){
		call_result = render_bar_normal(apm, &apm->barcolor_low);
	}else if((apm->battery_flag & BATTERY_FLAG_CRITICAL) != 0){
		call_result = render_bar_normal(apm, &apm->barcolor_critical);
	}else{
		PRINT_ERR(0, ERR_ERROR);
		return -1;
	}
	if(call_result != 0){
		PRINT_ERR(0, ERR_ERROR);
		return call_result;
	}

    return 0;
}

int render_label(apm_t* apm){
	char	buff[128] = "";

	if(apm->remain_percent != -1){
		sprintf(buff, "%s%ld%%\n", buff, apm->remain_percent);
	}else{
		sprintf(buff, "%s--%%\n", buff);
	}

	if(apm->remain_time != -1){
		sprintf(buff, "%s%ld%s\n", buff, apm->remain_time, apm->unit);
	}else{
		sprintf(buff, "%s----\n", buff);
	}

	switch(apm->line_status){
	case AC_OFFLINE:
		strcat(buff, "AC:OFF");
		break;
	case AC_ONLINE:
		strcat(buff, "AC:ON");
		break;
	case AC_BKUP:
		strcat(buff, "AC:BK");
		break;
	default:
		strcat(buff, "AC:--");
		break;
	}

	Epplet_change_label(apm->lbl, buff);

	return 0;
}

int render_bar_frame(apm_t* apm){
	Epplet_draw_outline(
        apm->epplet_window,
        BAR_OUTLINE_LEFT, BAR_OUTLINE_TOP,
        BAR_OUTLINE_WIDTH, BAR_OUTLINE_HEIGHT,
        BAR_OUTLINE_RED, BAR_OUTLINE_GREEN, BAR_OUTLINE_BLUE
    );

	return 0;
}

int render_bar_normal(apm_t* apm, color_t* color){
	int	bar_height;

	bar_height = BAR_HEIGHT*apm->remain_percent/100;
	Epplet_draw_box(
		apm->epplet_window,
		BAR_LEFT, BAR_TOP +(BAR_HEIGHT-bar_height),
		BAR_WIDTH, bar_height,
		color->red, color->green, color->blue
	);
	
	return 0;
}

int render_bar_nobattery(apm_t* apm){
	Epplet_draw_line(
		apm->epplet_window,
		BAR_LEFT, BAR_TOP, BAR_LEFT+BAR_WIDTH, BAR_TOP+BAR_HEIGHT,
		BAR_OUTLINE_RED, BAR_OUTLINE_GREEN, BAR_OUTLINE_BLUE
	);
	Epplet_draw_line(
		apm->epplet_window,
		BAR_LEFT+BAR_WIDTH, BAR_TOP, BAR_LEFT, BAR_TOP+BAR_HEIGHT,
		BAR_OUTLINE_RED, BAR_OUTLINE_GREEN, BAR_OUTLINE_BLUE
	);
	return 0;
}

int render_bar_unknown(apm_t* apm){
	Epplet_draw_line(
        apm->epplet_window,
        BAR_LEFT, BAR_TOP, BAR_LEFT+BAR_WIDTH, BAR_TOP+BAR_HEIGHT,
        BAR_OUTLINE_RED, BAR_OUTLINE_GREEN, BAR_OUTLINE_BLUE
    );
    Epplet_draw_line(
        apm->epplet_window,
        BAR_LEFT+BAR_WIDTH, BAR_TOP, BAR_LEFT, BAR_TOP+BAR_HEIGHT,
        BAR_OUTLINE_RED, BAR_OUTLINE_GREEN, BAR_OUTLINE_BLUE
    );

	return 0;
}

void print_err(char* file, long line, int is_syserr, int level){
	char	buff[256];

	if(level < ERR_THRESHOLD){
		return;
	}

	sprintf(buff, "%s:%ld", file, line);
	if(is_syserr){
		perror(buff);
	}else{
		fprintf(stderr, "%s\n", buff);
	}
}
