#ifndef	H_E_BATTERY
#define	H_E_BATTERY

#include<epplet.h>

/*====  ======================================================*/
#define	ERR_INFO	0
#define	ERR_CAUTION	10
#define	ERR_WARNING	20
#define	ERR_ERROR	30
#ifndef	ERR_THRESHOLD
#define	ERR_THRESHOLD	0
#endif

#define	APM_PROC	"/proc/apm"
#define	PROC_FORMAT	"%lf %lf %lx %lx %lx %lx %ld%% %ld %s"
#define	BUFF_SIZE	128

#define BATTERY_FLAG_UNKNOWN    0xff	    /* Хåƥ꡼ե饰 */
#define BATTERY_FLAG_HIGH       (1 << 0)	/* Хåƥ꡼ե饰̹ */
#define BATTERY_FLAG_LOW        (1 << 1)	/* Хåƥ꡼ե饰 */
#define BATTERY_FLAG_CRITICAL   (1 << 2)	/* Хåƥ꡼ե饰̶˾ */
#define BATTERY_FLAG_CHARGING   (1 << 3)	/* Хåƥ꡼ե饰 */
#define BATTERY_FLAG_NOBATTERY  (1 << 7)	/* Хåƥ꡼ե饰̵ */
#define AC_OFFLINE				0			/* AC */
#define AC_ONLINE   			1			/* AC³ */
#define AC_BKUP 				2			/* ХååŸ */

#define	EPPLET_NAME	"E-Battery"	
#define	EPPLET_VERSION	"0.0.0"
#define	EPPLET_DESCRIPTION	"A battery monitor epplet for notebook machine.;Shin MATSUDA"
#define	EPPLET_WIDTH	3	/* Epplet[block] */
#define	EPPLET_HEIGHT	3	/* Eppletι⤵[block] */

#define	INTERVAL	4.0	/* APMɤ߹ߴֳ[seconds] */

#define	LBL_LEFT	9	/* ٥뺸üɸ */
#define	LBL_TOP		10	/* ٥üɸ */
#define	LBL_SIZE	2	/* ٥ʸ(2: midium) */

#define	BAR_OUTLINE_LEFT	2						/* ̷Ⱥüɸ */
#define	BAR_OUTLINE_TOP		14						/* ̷Ⱦüɸ */
#define	BAR_OUTLINE_WIDTH	6						/* ̷ */
#define	BAR_OUTLINE_HEIGHT	32						/* ̷ȹ⤵ */
#define	BAR_OUTLINE_RED		0						/* ̷ȿʬ */
#define	BAR_OUTLINE_GREEN	0						/* ̷ȿʬ */
#define	BAR_OUTLINE_BLUE	0						/* ̷ȿʬ */
#define	BAR_LEFT			(BAR_OUTLINE_LEFT +1)	/* ̷׺üɸ */
#define	BAR_TOP				(BAR_OUTLINE_TOP +1)	/* ̷׾üɽ */
#define	BAR_WIDTH			(BAR_OUTLINE_WIDTH -2)	/* ̷ */
#define	BAR_HEIGHT			(BAR_OUTLINE_HEIGHT -2)	/* ̷׹⤵ */

/* ¤ */
typedef	struct{
	unsigned	char	red;	/* ʬ */
	unsigned	char	green;	/* ʬ */
	unsigned	char	blue;	/* ʬ */
}color_t;

/* ץꥱ¤ */
typedef struct{
	int	proc_fd;					/* APM_PROCؤΥե뼱̻ */
	unsigned	long	interval;	/* APM_PROCɤ߹ߴֳ */

	double	driver_version;			/* APM Linux driver version */
	double	bios_version;			/* APM BIOS version */
	long	flags;
	long	line_status;
	long	battery_status;
	long	battery_flag;	
	long	remain_percent;
	long	remain_time;
	char	unit[BUFF_SIZE];

	Window	epplet_window;
	Epplet_gadget	lbl;
	Epplet_gadget	lbl_percent;
	Epplet_gadget	lbl_time;
	Epplet_gadget	lbl_ac;

	color_t	barcolor_high;
	color_t	barcolor_low;
	color_t	barcolor_critical;
	color_t	barcolor_charging;
}apm_t;

#endif	/* H_E_BATTERY */
